autowatch =1;

inlets =3;
outlets =6;

setinletassist(0, "test value (int/ float)");
setinletassist(1, "consequents (list of floats between 0. and 1.)");
setinletassist(2, "universe of discourse ([min, max]");
setoutletassist(0, "membership values (list)");
setoutletassist(1, "number of members (int)");
setoutletassist(2, "to buttons");
setoutletassist(3, "to label 1");
setoutletassist(4, "to label 2");
setoutletassist(5, "to frame");

var inputArray = [];
var outputArray = [];
var predicates= [0.0, 0.25, 0.5, 0.75, 1.0];
var consequents= [1, 1, 1, 1, 1];
var range = [0.0, 1.0];

var sets = new Array(5);

function msg_int(n){	
	n = clip(n, range[0]+0.000001,range[1]-0.000001);
	inputArray.push(n);
	outputArray.push(getConsequent(n, predicates, consequents));
	outlet(0, outputArray);
	outlet(1, countNonZeros(outputArray));
}

function msg_float(n){
	n = clip(n, range[0]+0.000001,range[1]-0.000001);
	inputArray.push(n);
	outputArray.push(getConsequent(n, predicates, consequents));
	outlet(0, outputArray);
	outlet(1, countNonZeros(outputArray));
};


function list(){
	var n;
	var a = arrayfromargs(messagename,arguments);
	switch (this.inlet){
		case 0:
			n = clip(last(a), range[0]+0.000001,range[1]-0.000001);
			inputArray.push(n);
			outputArray.push(getConsequent(n, predicates, consequents));
		break;
		case 1:
			consequents = a;
			outputArray = interpList(inputArray);
		break;
		case 2:
			range = a;
			predicates = makeUniverse(range);
			outputArray = interpList(inputArray);
		break;
	}

outlet(0, outputArray);
outlet(1, countNonZeros(outputArray));

};

function set(but0, but1, but2, but3, but4){
	var a = [but0, but1, but2, but3, but4];
	
	for(var i=0, len =a.length; i<len; i++){outlet(2, [i, a[i]]);};
};
		
	
function makeUniverse(array){
	var unitUniverse = [0.0, 0.25, 0.5, 0.75, 1.0];
	var temp;
	 temp = unitUniverse.map(function(x) {return scale(x, 0.0, 1.0, log10(array[0]),log10(array[1]));});
	
	return temp.map(function(x) {return antilog10(x);});
};

function getConsequent(n, predicates, consequents){
	var pred, cons;
	var i=0;
	
	if(predicates.length == consequents.length){
	
		while(n>= predicates[i]){
			i++;
			}
		pred= [predicates[i-1], predicates[i]];
		cons= [consequents[i-1], consequents[i]];

		return interpolate(n, pred, cons);
		}
	else {
			post("non-matching predicate / consequent list lengths in fiveSets");
			post();
		}
}

function interpolate(n, x, y){
	return y[0]+(y[1]-y[0])*((n-x[0])/(x[1]-x[0]))
}

function interpList(a){
	var b=[];
	
	for(var i=0, len = a.length; i<len; i++){
		b[i] = getConsequent(a[i], predicates, consequents);
		}
	return b;
}

function countNonZeros(a) {
	var temp=0;
	for(var i=0, len = a.length; i<len; i++){if(a[i] >0) {temp++};};
return temp;
}; 

function clip(val, minimum, maximum){
	if(val< minimum) {val = minimum};
	if(val> maximum) {val = maximum};
	
	return val;
}

function clipArray(a, minimum, maximum){
	var temp = [];
	for(i=0, len = a.length; i<len; i++){
		temp[i] = clip(a[i], minimum, maximum);
	};
	return temp;
};
	
function reset(){
	inputArray = [];
	outputArray = [];
	predicates= [0.0, 0.25, 0.5, 0.75, 1.0];
	range = [0.0, 1.0];
};
	
function last(a){return a[a.length-1];};
	
function scale(val, inMin, inMax, outMin, outMax){return (((val - inMin)/(inMax - inMin))*(outMax - outMin))+outMin;};

function log10(val) {return Math.LOG10E*Math.log(val)};
	
function antilog10(val) {return Math.pow(10, val);};
	
function labels(label1, label2) {
	outlet(3, ["set", label1]);
	outlet(4, ["set", label2]);
	}

function bordercolor(red, green, blue, alpha) {
	outlet(2, ["all", "bordercolor", red, green, blue, alpha]);
	outlet(5, ["bordercolor", red, green, blue, alpha]);
	outlet(2, ["all","borderoncolor", red, green, blue, alpha]);
	}
	
function bgcolor(red, green, blue, alpha) {
	outlet(5, ["bgcolor", red, green, blue, alpha]);
	}
	
function toggleoffcolor(red, green, blue, alpha) {
	outlet(2, ["all", "bgcolor", red, green, blue, alpha]);
	outlet(2, ["all", "bgovercolor", red, green, blue, alpha]);
	}

function toggleoncolor(red, green, blue, alpha) {
	outlet(2, ["all", "bgoncolor", red, green, blue, alpha]);
	outlet(2, ["all", "bgoveroncolor", red, green, blue, alpha]);
	}